Index: uspace/lib/c/include/ipc/socket.h
===================================================================
--- uspace/lib/c/include/ipc/socket.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
+++ uspace/lib/c/include/ipc/socket.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -0,0 +1,230 @@
+/*
+ * Copyright (c) 2009 Lukas Mejdrech
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ * @{
+ */
+
+/** @file
+ * Socket messages.
+ */
+
+#ifndef LIBC_SOCKET_MESSAGES_H_
+#define LIBC_SOCKET_MESSAGES_H_
+
+#include <ipc/ipc.h>
+#include <ipc/net.h>
+
+/** Socket client messages. */
+typedef enum {
+	/** Creates a new socket. @see socket() */
+	NET_SOCKET = NET_SOCKET_FIRST,
+	/** Binds the socket. @see bind() */
+	NET_SOCKET_BIND,
+	/** Creates a new socket. @see socket() */
+	NET_SOCKET_LISTEN,
+	/** Accepts an incomming connection. @see accept() */
+	NET_SOCKET_ACCEPT,
+	/** Connects the socket. @see connect() */
+	NET_SOCKET_CONNECT,
+	/** Closes the socket. @see closesocket() */
+	NET_SOCKET_CLOSE,
+	/** Sends data via the stream socket. @see send() */
+	NET_SOCKET_SEND,
+	/** Sends data via the datagram socket. @see sendto() */
+	NET_SOCKET_SENDTO,
+	/** Receives data from the stream socket. @see socket() */
+	NET_SOCKET_RECV,
+	/** Receives data from the datagram socket. @see socket() */
+	NET_SOCKET_RECVFROM,
+	/** Gets the socket option. @see getsockopt() */
+	NET_SOCKET_GETSOCKOPT,
+	/** Sets the socket option. @see setsockopt() */
+	NET_SOCKET_SETSOCKOPT,
+	/** New socket for acceptence notification message. */
+	NET_SOCKET_ACCEPTED,
+	/** New data received notification message. */
+	NET_SOCKET_RECEIVED,
+	/** New socket data fragment size notification message. */
+	NET_SOCKET_DATA_FRAGMENT_SIZE
+} socket_messages;
+
+/** @name Socket specific message parameters definitions
+ */
+/*@{*/
+
+/** Sets the socket identifier in the message answer.
+ * @param[out] answer	The message answer structure.
+ */
+#define SOCKET_SET_SOCKET_ID(answer, value) \
+	do { \
+		ipcarg_t argument = (ipcarg_t) (value); \
+		IPC_SET_ARG1(answer, argument); \
+	} while (0)
+
+/** Returns the socket identifier message parameter.
+ * @param[in] call	The message call structure.
+ */
+#define SOCKET_GET_SOCKET_ID(call) \
+	({ \
+		int socket_id = (int) IPC_GET_ARG1(call); \
+		socket_id; \
+	})
+
+/** Sets the read data length in the message answer.
+ * @param[out] answer	The message answer structure.
+ */
+#define SOCKET_SET_READ_DATA_LENGTH(answer, value) \
+	do { \
+		ipcarg_t argument = (ipcarg_t) (value); \
+		IPC_SET_ARG1(answer, argument); \
+	} while (0)
+
+/** Returns the read data length message parameter.
+ * @param[in] call	The message call structure.
+ */
+#define SOCKET_GET_READ_DATA_LENGTH(call) \
+	({ \
+		int data_length = (int) IPC_GET_ARG1(call); \
+		data_length; \
+	})
+
+/** Returns the backlog message parameter.
+ * @param[in] call	The message call structure.
+ */
+#define SOCKET_GET_BACKLOG(call) \
+	({ \
+		int backlog = (int) IPC_GET_ARG2(call); \
+		backlog; \
+	})
+
+/** Returns the option level message parameter.
+ * @param[in] call	The message call structure.
+ */
+#define SOCKET_GET_OPT_LEVEL(call) \
+	({ \
+		int opt_level = (int) IPC_GET_ARG2(call); \
+		opt_level; \
+	})
+
+/** Returns the data fragment size message parameter.
+ * @param[in] call	The message call structure.
+ */
+#define SOCKET_GET_DATA_FRAGMENT_SIZE(call) \
+	({ \
+		size_t size = (size_t) IPC_GET_ARG2(call); \
+		size; \
+	})
+
+/** Sets the data fragment size in the message answer.
+ * @param[out] answer	The message answer structure.
+ */
+#define SOCKET_SET_DATA_FRAGMENT_SIZE(answer, value) \
+	do { \
+		ipcarg_t argument = (ipcarg_t) (value); \
+		IPC_SET_ARG2(answer, argument); \
+	} while (0)
+
+/** Sets the address length in the message answer.
+ * @param[out] answer	The message answer structure.
+ */
+#define SOCKET_SET_ADDRESS_LENGTH(answer, value) \
+	do { \
+		ipcarg_t argument = (ipcarg_t) (value); \
+		IPC_SET_ARG3(answer, argument);\
+	} while (0)
+
+/** Returns the address length message parameter.
+ * @param[in] call	The message call structure.
+ */
+#define SOCKET_GET_ADDRESS_LENGTH(call) \
+	({ \
+		socklen_t address_length = (socklen_t) IPC_GET_ARG3(call); \
+		address_length; \
+	})
+
+/** Sets the header size in the message answer.
+ * @param[out] answer	The message answer structure.
+ */
+#define SOCKET_SET_HEADER_SIZE(answer, value) \
+	do { \
+		ipcarg_t argument = (ipcarg_t) (value); \
+		IPC_SET_ARG3(answer, argument); \
+	} while (0)
+
+/** Returns the header size message parameter.
+ *  @param[in] call	The message call structure.
+ */
+#define SOCKET_GET_HEADER_SIZE(call) \
+	({ \
+		size_t size = (size_t) IPC_GET_ARG3(call); \
+		size; \
+	})
+
+/** Returns the flags message parameter.
+ *  @param[in] call	The message call structure.
+ */
+#define SOCKET_GET_FLAGS(call) \
+	({ \
+		int flags = (int) IPC_GET_ARG4(call); \
+		flags; \
+	})
+
+/** Returns the option name message parameter.
+ *  @param[in] call	The message call structure.
+ */
+#define SOCKET_GET_OPT_NAME(call) \
+	({ \
+		int opt_name = (int) IPC_GET_ARG4(call); \
+		opt_name; \
+	})
+
+/** Returns the data fragments message parameter.
+ *  @param[in] call	The message call structure.
+ */
+#define SOCKET_GET_DATA_FRAGMENTS(call) \
+	({ \
+		int fragments = (int) IPC_GET_ARG5(call); \
+		fragments; \
+	})
+
+/** Returns the new socket identifier message parameter.
+ *  @param[in] call	The message call structure.
+ */
+#define SOCKET_GET_NEW_SOCKET_ID(call) \
+	({ \
+		int socket_id = (int) IPC_GET_ARG5(call); \
+		socket_id; \
+	})
+
+/*@}*/
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/c/include/ipc/tl.h
===================================================================
--- uspace/lib/c/include/ipc/tl.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
+++ uspace/lib/c/include/ipc/tl.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -0,0 +1,55 @@
+/*
+ * Copyright (c) 2009 Lukas Mejdrech
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ * @{
+ */
+
+/** @file
+ * Transport layer modules messages.
+ * @see tl_interface.h
+ */
+
+#ifndef LIBC_TL_MESSAGES_H_
+#define LIBC_TL_MESSAGES_H_
+
+#include <ipc/ipc.h>
+#include <ipc/net.h>
+
+/** Transport layer modules messages. */
+typedef enum {
+	/** Packet received message.
+	 * @see tl_received_msg()
+	 */
+	NET_TL_RECEIVED = NET_TL_FIRST
+} tl_messages;
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/c/include/net/device.h
===================================================================
--- uspace/lib/c/include/net/device.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
+++ uspace/lib/c/include/net/device.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -0,0 +1,141 @@
+/*
+ * Copyright (c) 2009 Lukas Mejdrech
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ * @{
+ */
+
+/** @file
+ * Device identifier, state and usage statistics.
+ */
+
+#ifndef LIBC_DEVICE_ID_TYPE_H_
+#define LIBC_DEVICE_ID_TYPE_H_
+
+#include <adt/int_map.h>
+
+/** Device identifier to generic type map declaration. */
+#define DEVICE_MAP_DECLARE	INT_MAP_DECLARE
+
+/** Device identifier to generic type map implementation. */
+#define DEVICE_MAP_IMPLEMENT	INT_MAP_IMPLEMENT
+
+/** Invalid device identifier. */
+#define DEVICE_INVALID_ID	(-1)
+
+/** Device identifier type. */
+typedef int device_id_t;
+
+/** Device state type. */
+typedef enum device_state device_state_t;
+
+/** Type definition of the device usage statistics.
+ * @see device_stats
+ */
+typedef struct device_stats device_stats_t;
+
+/** Type definition of the device usage statistics pointer.
+ * @see device_stats
+ */
+typedef device_stats_t *device_stats_ref;
+
+/** Device state. */
+enum device_state {
+	/** Device not present or not initialized. */
+	NETIF_NULL = 0,
+	/** Device present and stopped. */
+	NETIF_STOPPED,
+	/** Device present and active. */
+	NETIF_ACTIVE,
+	/** Device present but unable to transmit. */
+	NETIF_CARRIER_LOST
+};
+
+/** Device usage statistics. */
+struct device_stats {
+	/** Total packets received. */
+	unsigned long receive_packets;
+	/** Total packets transmitted. */
+	unsigned long send_packets;
+	/** Total bytes received. */
+	unsigned long receive_bytes;
+	/** Total bytes transmitted. */
+	unsigned long send_bytes;
+	/** Bad packets received counter. */
+	unsigned long receive_errors;
+	/** Packet transmition problems counter. */
+	unsigned long send_errors;
+	/** No space in buffers counter. */
+	unsigned long receive_dropped;
+	/** No space available counter. */
+	unsigned long send_dropped;
+	/** Total multicast packets received. */
+	unsigned long multicast;
+	/** The number of collisions due to congestion on the medium. */
+	unsigned long collisions;
+
+	/* detailed receive_errors */
+
+	/** Received packet length error counter. */
+	unsigned long receive_length_errors;
+	/** Receiver buffer overflow counter. */
+	unsigned long receive_over_errors;
+	/** Received packet with crc error counter. */
+	unsigned long receive_crc_errors;
+	/** Received frame alignment error counter. */
+	unsigned long receive_frame_errors;
+	/** Receiver fifo overrun counter. */
+	unsigned long receive_fifo_errors;
+	/** Receiver missed packet counter. */
+	unsigned long receive_missed_errors;
+
+	/* detailed send_errors */
+
+	/** Transmitter aborted counter. */
+	unsigned long send_aborted_errors;
+	/** Transmitter carrier errors counter. */
+	unsigned long send_carrier_errors;
+	/** Transmitter fifo overrun counter. */
+	unsigned long send_fifo_errors;
+	/** Transmitter carrier errors counter. */
+	unsigned long send_heartbeat_errors;
+	/** Transmitter window errors counter. */
+	unsigned long send_window_errors;
+
+	/* for cslip etc */
+	
+	/** Total compressed packets received. */
+	unsigned long receive_compressed;
+	/** Total compressed packet transmitted. */
+	unsigned long send_compressed;
+};
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/c/include/net/icmp_api.h
===================================================================
--- uspace/lib/c/include/net/icmp_api.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
+++ uspace/lib/c/include/net/icmp_api.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -0,0 +1,63 @@
+/*
+ * Copyright (c) 2009 Lukas Mejdrech
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ * @{
+ */
+
+/** @file
+ * ICMP module application interface.
+ */
+
+#ifndef LIBC_ICMP_API_H_
+#define LIBC_ICMP_API_H_
+
+#include <net/socket_codes.h>
+#include <net/inet.h>
+#include <sys/types.h>
+#include <sys/time.h>
+
+#include <adt/measured_strings.h>
+#include <net/ip_codes.h>
+#include <net/icmp_codes.h>
+#include <net/icmp_common.h>
+
+/** @name ICMP module application interface
+ * This interface is used by other application modules.
+ */
+/*@{*/
+
+extern int icmp_echo_msg(int, size_t, mseconds_t, ip_ttl_t, ip_tos_t, int,
+    const struct sockaddr *, socklen_t);
+
+/*@}*/
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/c/include/net/icmp_codes.h
===================================================================
--- uspace/lib/c/include/net/icmp_codes.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
+++ uspace/lib/c/include/net/icmp_codes.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -0,0 +1,280 @@
+/*
+ * Copyright (c) 2009 Lukas Mejdrech
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ *  @{
+ */
+
+/** @file
+ * ICMP types and codes according to the on-line IANA - ICMP Type Numbers
+ *
+ * http://www.iana.org/assignments/icmp-parameters>
+ *
+ * cited September 14 2009.
+ */
+
+#ifndef LIBC_ICMP_CODES_H_
+#define LIBC_ICMP_CODES_H_
+
+/** ICMP type type definition. */
+typedef uint8_t icmp_type_t;
+
+/** ICMP code type definition. */
+typedef uint8_t icmp_code_t;
+
+/** ICMP parameter type definition. */
+typedef uint16_t icmp_param_t;
+
+/** @name ICMP types definitions */
+/*@{*/
+
+/** Echo Reply. */
+#define ICMP_ECHOREPLY		0
+
+/** Destination Unreachable. */
+#define ICMP_DEST_UNREACH	3
+
+/** Source Quench. */
+#define ICMP_SOURCE_QUENCH	4
+
+/** Redirect. */
+#define ICMP_REDIRECT		5
+
+/** Alternate Host Address. */
+#define ICMP_ALTERNATE_ADDR	6
+
+/** Echo Request. */
+#define ICMP_ECHO		8
+
+/** Router Advertisement. */
+#define ICMP_ROUTER_ADV		9
+
+/** Router solicitation. */
+#define ICMP_ROUTER_SOL		10
+
+/** Time Exceeded. */
+#define ICMP_TIME_EXCEEDED	11
+
+/** Parameter Problem. */
+#define ICMP_PARAMETERPROB	12
+
+/** Timestamp Request. */
+#define ICMP_TIMESTAMP		13
+
+/** Timestamp Reply. */
+#define ICMP_TIMESTAMPREPLY	14
+
+/** Information Request. */
+#define ICMP_INFO_REQUEST	15
+
+/** Information Reply. */
+#define ICMP_INFO_REPLY		16
+
+/** Address Mask Request. */
+#define ICMP_ADDRESS		17
+
+/** Address Mask Reply. */
+#define ICMP_ADDRESSREPLY	18
+
+/** Traceroute. */
+#define ICMP_TRACEROUTE		30
+
+/** Datagram Conversion Error. */
+#define ICMP_CONVERSION_ERROR	31
+
+/** Mobile Host Redirect. */
+#define ICMP_REDIRECT_MOBILE	32
+
+/** IPv6 Where-Are-You. */
+#define ICMP_IPV6_WHERE_ARE_YOU	33
+
+/** IPv6 I-Am-Here. */
+#define ICMP_IPV6_I_AM_HERE	34
+
+/** Mobile Registration Request. */
+#define ICMP_MOBILE_REQUEST	35
+
+/** Mobile Registration Reply. */
+#define ICMP_MOBILE_REPLY	36
+
+/** Domain name request. */
+#define ICMP_DN_REQUEST		37
+
+/** Domain name reply. */
+#define ICMP_DN_REPLY		38
+
+/** SKIP. */
+#define ICMP_SKIP		39
+
+/** Photuris. */
+#define ICMP_PHOTURIS		40
+
+/*@}*/
+
+/** @name ICMP_DEST_UNREACH codes definitions
+ */
+/*@{*/
+
+/** Network Unreachable. */
+#define ICMP_NET_UNREACH	0
+
+/** Host Unreachable. */
+#define ICMP_HOST_UNREACH	1
+
+/** Protocol Unreachable. */
+#define ICMP_PROT_UNREACH	2
+
+/** Port Unreachable. */
+#define ICMP_PORT_UNREACH	3
+
+/** Fragmentation needed but the Do Not Fragment bit was set. */
+#define ICMP_FRAG_NEEDED	4
+
+/** Source Route failed. */
+#define ICMP_SR_FAILED		5
+
+/** Destination network unknown. */
+#define ICMP_NET_UNKNOWN	6
+
+/** Destination host unknown. */
+#define ICMP_HOST_UNKNOWN	7
+
+/** Source host isolated (obsolete). */
+#define ICMP_HOST_ISOLATED	8
+
+/** Destination network administratively prohibited. */
+#define ICMP_NET_ANO		9
+
+/** Destination host administratively prohibited. */
+#define ICMP_HOST_ANO		10
+
+/** Network unreachable for this type of service. */
+#define ICMP_NET_UNR_TOS	11
+
+/** Host unreachable for this type of service. */
+#define ICMP_HOST_UNR_TOS	12
+
+/** Communication administratively prohibited by filtering. */
+#define ICMP_PKT_FILTERED	13
+
+/** Host precedence violation. */
+#define ICMP_PREC_VIOLATION	14
+
+/** Precedence cutoff in effect. */
+#define ICMP_PREC_CUTOFF	15
+
+/*@}*/
+
+/** @name ICMP_REDIRECT codes definitions */
+/*@{*/
+
+/** Network redirect (or subnet). */
+#define ICMP_REDIR_NET		0
+
+/** Host redirect. */
+#define ICMP_REDIR_HOST		1
+
+/** Network redirect for this type of service. */
+#define ICMP_REDIR_NETTOS	2
+
+/** Host redirect for this type of service. */
+#define ICMP_REDIR_HOSTTOS	3
+
+/*@}*/
+
+/** @name ICMP_ALTERNATE_ADDRESS codes definitions */
+/*@{*/
+
+/** Alternate address for host. */
+#define ICMP_ALTERNATE_HOST	0
+
+/*@}*/
+
+/** @name ICMP_ROUTER_ADV codes definitions */
+/*@{*/
+
+/** Normal router advertisement. */
+#define ICMP_ROUTER_NORMAL	0
+
+/** Does not route common traffic. */
+#define ICMP_ROUTER_NO_NORMAL_TRAFFIC	16
+
+/*@}*/
+
+/** @name ICMP_TIME_EXCEEDED codes definitions */
+/*@{*/
+
+/** Transit TTL exceeded. */
+#define ICMP_EXC_TTL		0
+
+/** Reassembly TTL exceeded. */
+#define ICMP_EXC_FRAGTIME	1
+
+/*@}*/
+
+/** @name ICMP_PARAMETERPROB codes definitions */
+/*@{*/
+
+/** Pointer indicates the error. */
+#define ICMP_PARAM_POINTER	0
+
+/** Missing required option. */
+#define ICMP_PARAM_MISSING	1
+
+/** Bad length. */
+#define ICMP_PARAM_LENGTH	2
+
+/*@}*/
+
+/** @name ICMP_PHOTURIS codes definitions */
+/*@{*/
+
+/** Bad SPI. */
+#define ICMP_PHOTURIS_BAD_SPI			0
+
+/** Authentication failed. */
+#define ICMP_PHOTURIS_AUTHENTICATION		1
+
+/** Decompression failed. */
+#define ICMP_PHOTURIS_DECOMPRESSION		2
+
+/** Decryption failed. */
+#define ICMP_PHOTURIS_DECRYPTION		3
+
+/** Need authentication. */
+#define ICMP_PHOTURIS_NEED_AUTHENTICATION	4
+
+/** Need authorization. */
+#define ICMP_PHOTURIS_NEED_AUTHORIZATION	5
+
+/*@}*/
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/c/include/net/icmp_common.h
===================================================================
--- uspace/lib/c/include/net/icmp_common.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
+++ uspace/lib/c/include/net/icmp_common.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -0,0 +1,51 @@
+/*
+ * Copyright (c) 2009 Lukas Mejdrech
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ *  @{
+ */
+
+/** @file
+ * ICMP module common interface.
+ */
+
+#ifndef LIBC_ICMP_COMMON_H_
+#define LIBC_ICMP_COMMON_H_
+
+#include <ipc/services.h>
+#include <sys/time.h>
+
+/** Default timeout for incoming connections in microseconds. */
+#define ICMP_CONNECT_TIMEOUT	(1 * 1000 * 1000)
+
+extern int icmp_connect_module(services_t, suseconds_t);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/c/include/net/in.h
===================================================================
--- uspace/lib/c/include/net/in.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
+++ uspace/lib/c/include/net/in.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -0,0 +1,80 @@
+/*
+ * Copyright (c) 2009 Lukas Mejdrech
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ *  @{
+ */
+
+/** @file
+ *  INET family common definitions.
+ */
+
+#ifndef LIBC_IN_H_
+#define LIBC_IN_H_
+
+#include <net/inet.h>
+#include <net/ip_protocols.h>
+#include <sys/types.h>
+
+/** INET string address maximum length. */
+#define INET_ADDRSTRLEN		(4 * 3 + 3 + 1)
+
+/** Type definition of the INET address.
+ * @see in_addr
+ */
+typedef struct in_addr		in_addr_t;
+
+/** Type definition of the INET socket address.
+ * @see sockaddr_in
+ */
+typedef struct sockaddr_in	sockaddr_in_t;
+
+/** INET address. */
+struct in_addr {
+	/** 4 byte IP address. */
+	uint32_t s_addr;
+};
+
+/** INET socket address.
+ * @see sockaddr
+ */
+struct sockaddr_in {
+	/** Address family. Should be AF_INET. */
+	uint16_t sin_family;
+	/** Port number. */
+	uint16_t sin_port;
+	/** Internet address. */
+	struct in_addr sin_addr;
+	/** Padding to meet the sockaddr size. */
+	uint8_t sin_zero[8];
+};
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/c/include/net/in6.h
===================================================================
--- uspace/lib/c/include/net/in6.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
+++ uspace/lib/c/include/net/in6.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -0,0 +1,82 @@
+/*
+ * Copyright (c) 2009 Lukas Mejdrech
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ *  @{
+ */
+
+/** @file
+ *  INET6 family common definitions.
+ */
+
+#ifndef LIBC_IN6_H_
+#define LIBC_IN6_H_
+
+#include <net/inet.h>
+#include <net/ip_protocols.h>
+#include <sys/types.h>
+
+/** INET6 string address maximum length. */
+#define INET6_ADDRSTRLEN	(8 * 4 + 7 + 1)
+
+/** Type definition of the INET6 address.
+ * @see in6_addr
+ */
+typedef struct in6_addr	in6_addr_t;
+
+/** Type definition of the INET6 socket address.
+ * @see sockaddr_in6
+ */
+typedef struct sockaddr_in6	sockaddr_in6_t;
+
+/** INET6 address. */
+struct in6_addr {
+	/** 16 byte IPv6 address. */
+	unsigned char s6_addr[16];
+};
+
+/** INET6 socket address.
+ * @see sockaddr
+ */
+struct sockaddr_in6 {
+	/** Address family. Should be AF_INET6. */
+	uint16_t sin6_family;
+	/** Port number. */
+	uint16_t sin6_port;
+	/** IPv6 flow information. */
+	uint32_t sin6_flowinfo;
+	/** IPv6 address. */
+	struct in6_addr sin6_addr;
+	/** Scope identifier. */
+	uint32_t sin6_scope_id;
+};
+
+#endif
+
+/** @}
+ */
